import numpy as np

def function_by_pg_NN(x_test,x_dot, ts, nn_model, allhx, allgx):
    x_input = np.array([0] * 8, dtype=float)
    y_res = [0] * (len(x_test) - 7)
    x_dot_res = [0] * (len(x_test) - 7)
    x_res = [0] * (len(x_test) - 7)
    hx = np.array([0], dtype=float)
    gx = np.array([0], dtype=float)

    for i in range(7):
        x_input[i] = np.float(x_test[i])
    x_input[7] = ts[7]
    x_dot_current = x_dot[7]
    gx[0] = allgx[6]

    for i in range(len(x_test) - 7):
        hx[0] = allhx[i + 6]
        x = x_input
        x = np.expand_dims(x, 0)
        x2 = np.expand_dims(hx,0)
        x_insert =np.expand_dims(gx, 0)
        x_ddot = nn_model.model.predict([x, x_insert, x2])
        y_res[i] = x_ddot
        x_dot_current = x_dot_current + y_res[i] * (abs(ts[1]-ts[0]))
        x_dot_res[i] = x_dot_current
        x_res[i] = x_input[6] + x_dot_res[i] * (abs(ts[1]-ts[0]))
        for j in range(6):
            x_input[j] = x_input[j + 1]
        x_input[7] = ts[i + 7]
        x_input[6] = x_res[i]
        gx[0] = x_res[i]*x_res[i]*x_res[i]

    return(x_res, x_dot_res)


