import numpy as np

def eq_to_data(xpoints, x_dot, x_ddot, ts, hx, gx):
    columns = 8
    rows = int(len(xpoints)-7)
    x_data = [[0 for c in range(columns)] for r in range(rows)]
    y_data = [0] * rows
    hx_data = [0] * rows
    gx_data = [0] * rows
    x_indicator = 0
    while x_indicator < rows:
        x_data[x_indicator][0] = xpoints[x_indicator]
        x_data[x_indicator][1] = xpoints[x_indicator + 1]
        x_data[x_indicator][2] = xpoints[x_indicator + 2]
        x_data[x_indicator][3] = xpoints[x_indicator + 3]
        x_data[x_indicator][4] = xpoints[x_indicator + 4]
        x_data[x_indicator][5] = xpoints[x_indicator + 5]
        x_data[x_indicator][6] = xpoints[x_indicator + 6]
        x_data[x_indicator][7] = ts[x_indicator]
        hx_data[x_indicator] = hx[x_indicator + 6]
        gx_data[x_indicator] = gx[x_indicator + 6]
        y_data[x_indicator] = x_ddot[x_indicator + 6]
        x_indicator = x_indicator + 1


    return np.array(x_data), np.array(y_data), np.array(hx_data), np.array(gx_data)
